<?php

if(!defined('GREGARIOUS_BUILD'))exit;

class gregarious {
	var $messages;
	var $options = array();
	var $pages = array();
	var $settings = array('last_update_check' => 0);
	function add_settings($settings_array){
		foreach($settings_array as $key => $value){
			add_option($key, $value);
			$this->settings[$key] = $value;
		}
	}
	function add_message( $msg, $class='saved' ){
		if(!greg_is_admin())return;
		$this->messages[] = array( 'message' => $msg, 'class' => $class );
	}
	function echo_messages(){
		if($this->messages){
			foreach( $this->messages as $msg ){
				echo '<div id="form_message" class='.$msg['class'].'><p>';
				echo $msg['message'];
				echo "</p></div>";
			}
		}
	}
	function add_page( $title, $icon='', $code='', $id='', $url = false ){
		if(!greg_is_admin())return;
		$this->pages[] = array(
		'title' => $title, 'icon' => $icon, 'code' => $code, 'url' => $url, 'id' => $id
		);
	}
}

$gregarious = &New gregarious;

function greg_uri( $what='main' ) {
	return ( 'main'==$what ) ? get_bloginfo('wpurl').GREGARIOUS_FILEPATH : get_bloginfo('wpurl').GREGARIOUS_ADMIN_URI;
}
function greg_is_admin(){
	return (is_admin() && ($_REQUEST['page']=='gregarious'));
}

function greg_get_option($setting){
	return get_option (OPT_PREFIX.$setting);
}
function greg_update_options($settings, $values){
	foreach ( $settings as $setting ){
		greg_update_option ( $setting, $values[$setting] );
	}
}
function greg_update_option($setting, $value){
	update_option ( OPT_PREFIX.$setting, $value );
}
function load_greg_settings(){
	global $gregarious;
	if( !is_array($gregarious->settings) )return;
	foreach( $gregarious->settings as $setting => $value ){
		add_option(OPT_PREFIX.$setting, $value);
	}
}
function greg_delete_options($what='all'){
	global $gregarious;
	if( !is_array($gregarious->settings) )return;
	if('all'==$what){
		foreach( $gregarious->settings as $module => $settings_array ){
			delete_option(OPT_PREFIX.$module);
		}
	} else {
		delete_option(OPT_PREFIX.$what);
	}
}
function greg_reset_options($what='all'){
	global $gregarious;
	if( !is_array($gregarious->settings) )return;
	if('all'==$what){
		foreach( $gregarious->settings as $module => $settings_array ){
			update_option(OPT_PREFIX.$module, $settings_array);
		}
	} else {
		update_option(OPT_PREFIX.$what, $gregarious->settings[$what]);
	}
}
function greg_options($option, $module=''){
	if($module){
		global $gregarious;
		if(!array_key_exists($module, $gregarious->options)){
			$gregarious->options[$module] = greg_get_option($module);
		}
		return $gregarious->options[$module][$option];
	} else {
		return greg_get_option($option);
	}
}
function modules(){
	return greg_get_option('modules');
}
/* Returns path to each php module file */
function get_all_module_paths ( $only_active = false , $path = '' , $maxdepth = -1 , $d = 0 )
{
	$active = modules();
	if(!is_array($active)) $active=array();
	if(!$path) $path = GREGARIOUS_ABSPATH.'modules/';
   if( substr( $path , strlen ( $path ) - 1 ) != '/' ) { $path .= '/' ; }
   $dirlist = array();
//   if ( $mode != "FILES" ) { $dirlist[] = $path; }
if( !file_exists($path) ) return array();
   if ( $handle = opendir ( $path ) )
   {
       while ( false !== ( $file = readdir ( $handle ) ) )
       {
           if ( substr($file, 0, 1) != "." && substr($file, 0, 4) != "inc_" )
           {
               $file = $path . $file ;
               if ( ! is_dir ( $file ) ) {
//               		if ( $mode != "DIRS"  && substr($file, strlen($file) - 4) == '.php' )
               		if ( substr($file, strlen($file) - 4) == '.php' ) {
               			if ( !$only_active ){
	               			$dirlist[] = $file;
               			} elseif( array_key_exists(substr($file, strlen(GREGARIOUS_ABSPATH.'modules/')), $active) ) {
               				$dirlist[] = $file;
               			}
               		}
               }
               elseif ( $d >=0 && ($d < $maxdepth || $maxdepth < 0) )
               {
                   $result = get_all_module_paths( $only_active , $file . '/' , $maxdepth , $d + 1 );
                   $dirlist = array_merge( $dirlist , $result );
               }
       		}
       }
       closedir ( $handle ) ;
   }
   if ( $d == 0 ) { natcasesort ( $dirlist ); }
   return ( $dirlist );
}
function get_all_modules($onlyactive = 0, $url = 0){
	$array = get_all_module_paths($onlyactive);
	foreach( $array as $value ){
		if( $url ){
			$output = substr($value, strlen(GREGARIOUS_ABSPATH.'modules/'));
		} else {
			$output = strrchr($value, '/');
			$output = substr($output, 1);
			$output = substr($output, 0, -4);
		}
		$modules[] = $output;
	}
	return $modules;
}
function load_modules(){
	$modules = modules();
	if( !is_array($modules) ) return;
	foreach ( $modules as $module_path => $on ){
		if( file_exists(GREGARIOUS_ABSPATH.'modules/'.$module_path) ){
			include_once GREGARIOUS_ABSPATH.'modules/'.$module_path;
		} else {
			deactivate_module($module_path);
		}
	}
	modules_do_action('init');
	load_greg_settings();
}
function activate_module($module){
	$modules = modules();
	$modules[$module] = 1;
	update_modules($modules);
}
function deactivate_module($module){
	$modules = modules();
	if(array_key_exists($module, $modules)){
		unset($modules[$module]);
		update_modules($modules);
	}
}
function update_modules($array){
	greg_update_option ( 'modules', $array );
}
function modules_do_action($action=''){
	$modules = get_all_modules(1, false);
	$results = array();
	if ( is_array($modules) ){
	foreach ($modules as $moduleName){
		$module = 'module_'.str_replace('-','',$moduleName);
		if( is_callable( array($module, $action) ) ){
			$results[$moduleName] = eval ('return '.$module.'::'.$action.'();');
		}
	}
	}
	return $results;
}

class DiggAPIUser {}
class DiggAPITopic {}
class DiggAPIContainer {}
class DiggAPIStory {}
class DiggAPIStories {}

function digg_api_call($url=''){
	ini_set('user_agent', get_bloginfo('name').'/Wordpress, via Gregarious/2.0 (Build '.GREGARIOUS_BUILD.')');
	$url .= '&type=php&appkey='.rawurlencode(get_bloginfo('url'));
	$data = wp_remote_fopen("http://services.digg.com/$url");
	if( !$data ) return false;
	$apidata = unserialize($data);
	if( !$apidata || $apidata->total < 1 ) return false;
	return $apidata;
}

function greg_save_meta($id, $key, $val){
	if(!update_post_meta($id, $key, $val)) add_post_meta($id, $key, $val);
}
function grab_sets( $settings, &$array ){
	parse_str($settings, $merge);
	foreach( $merge as $key => $value ){
		$array[$key] = $value;
	}
}
function hideOnID( $id = '' ){
	$data = trim(greg_get_option('dont_show_on'));
	if ( $data == '' ){
		return false;
	} else {
		$hidingArray = preg_split ( '#[ ,]+#i', $data );
		return (in_array($id, $hidingArray));
	}
}
function reload_after(){
	die('<meta http-equiv="refresh" content="0;url='.greg_uri('admin').'">');
	exit;
}
function upd_req($last_upd, $interval=0, $force, $updkey=''){
	if(!$interval)
		$interval = greg_get_option('de_cache_duration');
	if( $force || (time()-$last_upd) > $interval ){
		if($updkey)
			greg_update_option($updkey, time());
		return true;
	} else {
		return false;
	}
}

/* Compatibillity with older WP. */

if(!function_exists('attribute_escape')){
	function attribute_escape($text) {
		return htmlspecialchars($text);
	}
}
?>