<?php
/*
Plugin Name: Gregarious
Plugin URI: http://dev.lipidity.com/feature/wp-plugin-gregarious
Description: Social bookmarking
Version: 1.9.10c
Author: Ankur Kothari
Author URI: http://dev.lipidity.com/
*/
/*
todo: Template tags / docs
todo: check if post save on home works, securely
*/
/*
http://dev.lipidity.com/ for any help/support/requests/suggestions/updates
or send me an email at ankur@lipidity.com
*/

define('OPT_PREFIX', 'greg_');

	$path = __FILE__;
    if (!$path){$path=$_SERVER['PHP_SELF'];}
    $current_directory = dirname($path);
    $current_directory = str_replace('\\','/',$current_directory);
    $current_directory = explode('/',$current_directory);
    $current_directory = end($current_directory);
	if(empty($current_directory) || !$current_directory)
		$current_directory = 'gregarious';
	define('GREGARIOUS_FOLDER', $current_directory);

define('GREGARIOUS_FILEPATH', '/wp-content/plugins/'.GREGARIOUS_FOLDER.'/');
define('GREGARIOUS_ADMIN_URI', '/wp-admin/options-general.php?page=gregarious');

define('GREGARIOUS_BUILD', 61);

if ( !defined('PLUGINDIR') )
	define('PLUGINDIR', 'wp-content/plugins');

define('GREGARIOUS_ABSPATH', ABSPATH.PLUGINDIR.'/'.GREGARIOUS_FOLDER.'/');

require_once 'greg_functions.php';

load_plugin_textdomain('gregarious', GREGARIOUS_FILEPATH);

//===========================================================================
// START MAIN
//===========================================================================
$gregarious->add_page( __('Modules', 'gregarious'), 'resources/images/icn_HUD.png', 'page_modules();' );

// First run or updated, set defaults
$versioncheck = get_option('gregarious_version');
if( !$versioncheck || $versioncheck < GREGARIOUS_BUILD ){
	update_option('gregarious_version', GREGARIOUS_BUILD);
	$initmodules = modules();
	if( !is_array($initmodules) || count($initmodules)<1 ){
		$initmodules = array(
'digg-button/digg-button.php' => 1, 'digg-stats/digg-stats.php' => 1, 'share-this/share-this.php' => 1, 'reddit-button/reddit-button.php' => 1, 'post-badge/post-badge.php' => 1
		);
		foreach ( $initmodules as $module => $on ){
			if( file_exists(GREGARIOUS_ABSPATH.'modules/'.$module) ){
				$loading[$module]=1;
			}
		}
		greg_update_option ( 'modules', $loading );
	}
		modules_do_action ( 'reset_settings' );
		$gregarious->add_message(__('Gregarious upgraded successfully', 'gregarious'), 'updated');
} else if( $versioncheck > GREGARIOUS_BUILD ){
	update_option('gregarious_version', GREGARIOUS_BUILD);
	$gregarious->add_message(__("Successfully downgraded Gregarious"), 'updated');
}

		load_modules();

$gregarious->add_page( __('Edit Database', 'gregarious'), 'resources/images/icn_Database.png', '', '', greg_uri('admin').'&amp;keys=1' );

// ==========

add_action('admin_head', 'gregarious_admin_head');
function gregarious_admin_footer(){
	include GREGARIOUS_ABSPATH.'admin/admin_foot.php';
}

add_action('admin_footer', 'gregarious_admin_footer');
function gregarious_admin_head(){
	include GREGARIOUS_ABSPATH.'admin/admin_head.php';
}

if( isset($_REQUEST['keys']) ){
	add_action('admin_menu', 'gregarious_admin_keys');
} else {
	add_action('admin_menu', 'gregarious_admin_menu');
}
function gregarious_admin_menu(){
	add_submenu_page('options-general.php', 'Gregarious Setup', 'Gregarious', 8, 'gregarious', 'gregarious_menu');
}

function gregarious_menu(){
	include GREGARIOUS_ABSPATH.'admin/admin_options.php';
}

function gregarious_admin_keys(){
	add_submenu_page('options-general.php', 'Gregarious Setup', 'Gregarious', 8, 'gregarious', 'gregarious_keys');
}

function gregarious_keys(){
	include GREGARIOUS_ABSPATH.'admin/admin_keys.php';
}

/*
add_query_arg(newkey, newvalue, oldquery_or_uri) or
add_query_arg(associative_array, oldquery_or_uri)
remove_query_arg(removekey, [oldquery_or_uri]) or
remove_query_arg(removekeyarray, [oldquery_or_uri])
*/

include_once GREGARIOUS_ABSPATH.'gregarious-widget.php';

?>