<?php
//================================================
// DIGG-BUTTON MODULE for GREGARIOUS
//================================================
// Provision of dynamic full or compact Digg
// button, "submit to Digg" links. Automatically
// detects referrals from Digg and adds Digg URL
// to post meta accordingly.
//================================================
// Gregarious is copyright 2007 Ankur Kothari
// All rights reserved.
// -------------------------
// http://dev.lipidity.com/wp-plugin-gregarious
//================================================
//
// === TODO: ===
// Black list Digg pages against IDs
// on false Digg referrals
// todo: publicize [digg=] feature

if(isset($_REQUEST['update_digg'])){
	global $wpdb;
	$query = "SELECT ID, meta_value FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->posts.ID = $wpdb->postmeta.post_id WHERE meta_key='DiggUrl'";
	if ( $dugg_posts = $wpdb->get_results($query) ) {
		foreach($dugg_posts as $post){
			if( !get_post_meta($post->ID, 'DiggData', true) ){
				greg_save_meta($post->ID, 'DiggData', 'href='.$post->meta_value);
				delete_post_meta($post->ID, 'DiggUrl');
			}
		}
	} else {
		return false;
	}
}

/* BEGIN MAIN */

class module_diggbutton {
	function init(){
		global $gregarious;

		$gregarious->add_page( 'Digg Options', 'modules/digg-button/icn_Digg.png', 'page_digg();', 'badgeStyle' );

		$gregarious->add_settings ( array (
			'digg_refer_detect' => 1,
			'digg_email_notify' => 1,
			'digg_check_type' => 2,
			'digg_submit_style' => 'button',
			'digg_submit_style_image' => "http://digg.com/img/badges/32x32-digg-guy.gif",
			'digg_submit_style_text' => 'Digg This',
			'digg_badge_style' => 'button',
			'digg_badge_style_image' => "http://digg.com/img/badges/32x32-digg-guy.gif",
			'digg_badge_style_text' => 'Digg It',
			'digg_badge_bgcolor' => '#FFFFFF',
			'digg_inline_edit' => 1,
			'digg_curl_check' => 0
		) );
	}

	function postbadge_tags(){
		return array (
			array ( 'tag' => '%DIGG%', 'replacewith' => 'digg_button("",false)' ),
			array ( 'tag' => '%DIGG_BUTTON%', 'replacewith' => 'digg_button("skin=button",false)', 'deprecate' => 1 ),
			array ( 'tag' => '%DIGG_COMPACT%', 'replacewith' => 'digg_button("skin=compact",false)', 'deprecate' => 1 )
		);
	}

	function admin_js(){
		include GREGARIOUS_ABSPATH.'modules/digg-button/inc_admin-js.php';
	}

	function update_info(){
		return 100;
	}
}

//------------------------------------------
// TEMPLATE TAGS
//------------------------------------------
/*
todo: function digg_edit_link (){
	if ( current_user_can('manage_options') ){
		// delete Digg URL link?
		// edit Digg URL link?
	}
}
*/
function digg_button($settings = '', $echo = true){
	$result = "";

	global $wp_query; 
	$post = $wp_query->post;

$sets = array(
	'skin' => '',
	'bgcolor' => attribute_escape(greg_get_option('digg_badge_bgcolor')),
	'title' => $post->post_title,
	'bodytext' => '',
	'topic' => '',
	'postID' => $post->ID,
	'url' => '',
	'force' => 0,
	'dugg' => greg_get_option('digg_badge_style'),
	'undugg' => greg_get_option('digg_submit_style')
	);

	$ref = $_SERVER['HTTP_REFERER'];
//	$ref = "http://digg.com/videos_comedy/Jack_Black_sings_on_American_Idol"; // testing...

	grab_sets($settings, $sets);

	$sets['title'] = attribute_escape($sets['title']);
	$sets['bodytext'] = attribute_escape($sets['bodytext']);

	parse_str(get_post_meta($sets['postID'], 'DiggData', true));

if(!$href && greg_get_option('digg_refer_detect') && preg_match('#^http://(www\.)?digg\.com/.+#i', $ref) && !preg_match('#^http://(www\.)?digg\.com/(view|search|users|(.+?/upcoming(/(.*))?$))#i', $ref))
{
		$ref = preg_replace ('#^(.*)/who(?:/)?$#i', '$1', $ref);
		$ref = preg_replace ('#^(.*)/blog(?:/)?$#i', '$1', $ref);
		$ref = preg_replace ('#^(.*)/share(?:/)?$#i', '$1', $ref);

	$howcheck = greg_get_option('digg_check_type');
	if($howcheck == 2){
		if(store_diggdata($sets['postID'], $ref)){
			parse_str(get_post_meta($sets['postID'], 'DiggData', true));
			if(greg_get_option('digg_email_notify'))
				email_admin_on_digg($sets['postID'], $ref);
		}
	} elseif($howcheck == 1){
		$ref = preg_replace('#^http://(www\.)?digg\.com/videos/(.*)/(.*)#i', 'http://$1digg.com/videos_$2/$3', $ref);
		if(hybrid_scrape_check_digg($ref, get_permalink($sets['postID']))){
			greg_save_meta($sets['postID'], 'DiggUrl', $ref);
		}
	} else {
		$ref = preg_replace('#^http://(www\.)?digg\.com/videos/(.*)/(.*)#i', 'http://$1digg.com/videos_$2/$3', $ref);
		greg_save_meta($sets['postID'], 'DiggUrl', $ref);
	}
}

	if ( !$sets['force'] && hideOnID($sets['postID']) ){
		return '';
	}

	if( $sets['url'] ){
		$action = 'button';
		$digg_url = attribute_escape($sets['url']);
		$digg_skin = '';
	} elseif( $href ){
//		$action = $sets['dugg'];
		$digg_url = attribute_escape($href);
		$action = $digg_skin = ($sets['skin']) ? $sets['skin'] : $sets['dugg'];
		$text = attribute_escape(greg_get_option('digg_badge_style_text'));
		$img = attribute_escape(greg_get_option('digg_badge_style_image'));
	} elseif( $href = get_post_meta($sets['postID'], 'DiggUrl', true) ){
//		$action = $sets['dugg'];
		$digg_url = attribute_escape($href);
		$action = $digg_skin = ($sets['skin']) ? $sets['skin'] : $sets['dugg'];
		$text = attribute_escape(greg_get_option('digg_badge_style_text'));
		$img = attribute_escape(greg_get_option('digg_badge_style_image'));
	} else {
//		$action = $sets['undugg'];
		$action = $digg_skin = ($sets['skin']) ? $sets['skin'] : $sets['undugg'];
		$text = attribute_escape(greg_get_option('digg_submit_style_text'));
		$img = attribute_escape(greg_get_option('digg_submit_style_image'));
		$permalink = attribute_escape(get_permalink($sets['postID']));
		if( 'text' == $action || 'image' == $action ){
			$digg_url = "http://digg.com/submit?phase=2&amp;url=".$permalink."&amp;title=".$sets['title']."&amp;topic=".$sets['topic']."&amp;bodytext=".$sets['bodytext'];
		} else {
			$digg_url = $permalink;
			$digg_skin = ($sets['skin']) ? $sets['skin'] : $sets['undugg'];
		}
	}

	if( 'text' == $action ){
		$result .= "<a href='$digg_url' title='Bookmark this story on Digg.com'>$text</a>";
	} else if( 'image' == $action ){
		$result .= "<a href='$digg_url' title='Bookmark this story on Digg.com'><img src='$img' class='imgDigg' alt='$text' /></a>";
	} else if( 'button' == $action || 'compact' == $action ){
		$result .= "<script type='text/javascript'>
<!--
digg_url='$digg_url';
digg_skin = '$digg_skin';
digg_bgcolor = '{$sets['bgcolor']}';
digg_title = '{$sets['title']}';
digg_bodytext = '{$sets['bodytext']}';
digg_topic = '{$sets['topic']}';
//-->
</script>
<script type='text/javascript' src='http://digg.com/tools/diggthis.js'></script>
";
	}

	// What's this link?
	if($result)
		$result .= " 
		<a href='http://dev.lipidity.com/feature/wp-plugin-gregarious' title='WordPress Gregarious b".GREGARIOUS_BUILD."' class='digg_whats_this'>
		[?]
		</a>";

	if($echo) echo $result; else return $result;
}

//===========================================================================
// HELPER FUNCTIONS
//===========================================================================

function page_digg(){
	include GREGARIOUS_ABSPATH.'modules/digg-button/inc_admin-page.php';
}

function email_admin_on_digg($post_id, $digg_ref ) {
	global $wpdb;
	
	$post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE ID='$post_id' LIMIT 1");

	$notify_message  = sprintf( __('A new post was dugg by digg.com users. A link back to digg.com ( %1$s ) was automatically added to the post #%2$s "%3$s"', 'gregarious'), $digg_ref, $post_id, $post->post_title ) . "\r\n";
	$notify_message .= get_permalink($post->ID) . "\r\n\r\n";
	$subject = sprintf( __('[%1$s] A post has been dugg: "%2$s"', 'gregarious'), get_settings('blogname'), $post->post_title );
	$admin_email = get_settings('admin_email');

	$notify_message = apply_filters('post_dugg_text', $notify_message);
	$subject = apply_filters('post_dugg_subject', $subject);

	@wp_mail($admin_email, $subject, $notify_message);
    
	return true;
}

function hybrid_scrape_check_digg($digg_link, $the_permalink)
{
	ini_set('user_agent', get_bloginfo('name').'/Wordpress, via Gregarious/2.0 (Build '.GREGARIOUS_BUILD.')');
	if( $http_result = wp_remote_fopen($digg_link) ){
		$_ = preg_match('#<h3 id="title"><a href="(.*?)"(?: )?>#is', $http_result, $captures);
		return ($captures[1] == $the_permalink);
	} else {
		return true;
	}
}

function store_diggdata($id, $digg_href){
	$title = title_for_digg_url($digg_href);
	$data = digg_api_call('story/'.$title.'?');
	if( !$data ) return false;
	if( (string)$data->stories[0]->link == get_permalink($id) ){
		$r = 'link='.htmlentities($data->stories[0]->link, ENT_QUOTES);
		$r .= '&href='.htmlentities($data->stories[0]->href, ENT_QUOTES);
		greg_save_meta($id, 'DiggData', $r);
		return true;
	} else {
/*		echo 'link='.htmlentities($data->stories[0]->link, ENT_QUOTES);
		echo '&href='.htmlentities($data->stories[0]->href, ENT_QUOTES);
		echo "No match";*/
		return false;
	}
}

function title_for_digg_url($dugg){
	$dugg = preg_replace('#^http://(?:www\.)?digg\.com/videos/(.*?)/(.*?)#i', 'http://$1digg.com/videos_$1/$2', $dugg);
	return preg_replace('#^http://(?:www\.)?digg\.com/(.*?)/(.*?)(/(.*))*$#i', '$2', $dugg);
}

function digg_from_post($content){
	return preg_replace_callback("#\[digg=[a-zA-Z/_:\.]+\]#i", 'post_digg_button', $content);
}

function post_digg_button($matches){
	foreach($matches as $match){
		$match1 = preg_replace('#\[digg=((?:http://)?(?:www\.)?(?:[\.a-zA-Z/_:]+))\]#i', '$1', $match);
		return digg_button('skin=button&url='.$match1, false);
	}
}

add_filter('the_content', 'digg_from_post');

?>