<?php
//================================================
// FEEDFLARE MODULE for GREGARIOUS
//================================================
// Addition of FeedBurner FeedFlare to post
// content using PostBadge or template tags.
//================================================
// Gregarious is copyright 2007 Ankur Kothari
// All rights reserved.
// -------------------------
// http://dev.lipidity.com/wp-plugin-gregarious
//================================================
// Provides feed_flare() template tag
// and <%FLARE%> PostBadge tag to show
// FeedBurner FeedFlare.
// -------------------------
// FeedBurner account and feed required.
// Sign up at http://feedburner.com
//================================================

class module_feedflare {
	function init(){
		global $gregarious;
		$gregarious->add_settings ( array ( 'feedburner_url' => '' ) );
		$gregarious->add_page ( 'FeedFlare', 'modules/feed-flare/icn_Flare.png', 'page_feedflare();', 'feedFlare' );
	}

	function postbadge_tags(){
		return array (
		array (	'tag' => '%FLARE%', 'replacewith' => 'feed_flare("",false)' ),
		);
	}

	function update_info(){
		return 100;
	}
}

//------------------------------------------
// TEMPlATE TAGS
//------------------------------------------

function feed_flare($settings = '', $echo = true){
	global $wp_query;
	$post = $wp_query->post;
	$sets = array('postID' => $post->ID, 'before' => '', 'after' => '<span style="display:none">Gregarious FeedFlare</span>', 'force' => 0 );

	grab_sets($settings, $sets);
	if ( !$sets['force'] && hideOnID($sets['postID']) ){
		return '';
	}

	if( !$path = _get_feedburner_url() )
		return '';

	if( substr( $path, -1 ) == '/' ){
		$path = substr( $path, 0, strlen( $path ) -1 );
	}

	$path = str_replace ( 'feedburner.com/', 'feedburner.com/~s/', $path );

	$path .= '?i='.get_permalink($sets['postID']);

	$result = $sets['before'] . "<script src='$path' type='text/javascript'></script>" . $sets['after'];
	if($echo) echo $result;
	else return $result;
}

function _get_feedburner_url(){
	$feedurl = greg_get_option( 'feedburner_url' );
	if ( $feedurl ){
		return attribute_escape($feedurl);
	} else {
		$feedburner_settings = get_option('feedburner_settings');
		if( is_array($feedburner_settings) && ($feedurl = $feedburner_settings['feedburner_url']) ) {
			return attribute_escape($feedurl);
		} else {
			return false;
		}
	}
}

//------------------------------------------
// OPTIONS PAGE
//------------------------------------------

function page_feedflare(){
	$feedurl = _get_feedburner_url();
?>
<ul>
	<li class="page_code">
		<label class="wrapping"><?php _e('Feedburner feed URL', 'gregarious') ?>: <input type='text' name='feedburner_url' value='<?php echo $feedurl; ?>' />
		</label>
	</li>
	<li class="transmit">
		<a class="wrapping" href="http://www.feedburner.com/fb/a/publishers/feedflare;">About FeedFlare &raquo;</a>
	</li>
	<li class="stat">
		<a class="wrapping" href="http://www.feedburner.com/fb/a/dashboard;">FeedStats Dashboard &raquo;</a>
	</li>
</ul>

<?php
}

?>