<?php
//================================================
// POST-BADGE MODULE for GREGARIOUS
//================================================
// Appends content to posts, without the need for
// template editing. Can be extended by other
// modules.
//================================================
// Gregarious is copyright 2007 Ankur Kothari
// All rights reserved.
// -------------------------
// http://dev.lipidity.com/wp-plugin-gregarious
//================================================

class module_postbadge {

	function init(){
		global $gregarious;
		$gregarious->add_page( __('PostBadge', 'gregarious'), 'modules/post-badge/icn_postbadge.png', 'page_postbadge();', 'postBadge' );
//		$gregarious->add_page( 'Dugg Posts', 'icn_List.png', 'page_duggposts();', 'diggStats' );

		$gregarious->add_settings( array(
			'append_use' => 'on',
			'append_content' => "<div class='diggWrap'>%DIGG%</div>\n%SHARE%",
			'dont_show_on' => '',
			'append_conditionals' => array('is_single' => 1,
							'is_home' =>  1,
							'is_page' => 1,
							'is_category' => 0,
							'is_date' => 0 )
	) );
	}

	function admin_js(){
?>
function insertAtCursor(myField, myValue) {
	myField = $(myField);
	//IE support
	if (document.selection) {
		myField.focus();
		sel = document.selection.createRange();
		sel.text = myValue;
	}
	//MOZILLA/NETSCAPE support
	else if (myField.selectionStart || myField.selectionStart == '0') {
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		myField.value = myField.value.substring(0, startPos)
		+ myValue
		+ myField.value.substring(endPos, myField.value.length);
	} else {
		myField.value += myValue;
	}
}
<?php
	}

	function update_info(){
		return 100;
	}

}

//------------------------------------------
// TEMPLATE TAGS
//------------------------------------------

function get_post_badge($content = '', $append_content = ''){
	if ( hideOnID($sets['postID']) || function_exists('is_akst_page') && is_akst_page() )
		return $content;
	$conditionals = greg_get_option('append_conditionals');
	if ( (is_home() and $conditionals['is_home']) or
		(is_single() and $conditionals['is_single']) or
		(is_page() and $conditionals['is_page']) or
		(is_category() and $conditionals['is_category']) or
		(is_date() and $conditionals['is_date']) or 0)
	{
		if(!isset($append_content{3})) $append_content = greg_get_option('append_content');
		$replacements = modules_do_action('postbadge_tags');
		if( !count($replacements) ) return $content;
		foreach( $replacements as $replacement )
			foreach( $replacement as $tag )
				if(substr_count($append_content, $tag['tag']))
					$append_content =
						str_replace($tag['tag'],eval('return '.$tag['replacewith'].';'),$append_content);
		if( ($result = str_replace('%CONTENT%', $content, $append_content)) == $append_content )
			$result = $content.$append_content;
		return $result;
	}
	return $content;
}

function post_badge($content='', $append_content=''){
	echo get_post_badge($content, $append_content);
}

//------------------------------------------
// SET IT TO AUTO APPEND
//------------------------------------------
if( greg_get_option('append_use') ){
	add_filter('the_content', 'get_post_badge');
}
//------------------------------------------
// ADMIN OPTIONS PAGES
//------------------------------------------

/*function page_duggposts(){
	$sets = greg_get_option('digg_dont_show');

	echo '<ul>';
	echo '
			<li class="text"><label for="dont_show_on" class="wrapping">Hide on post IDs: <input type="text" name="dont_show_on" id="dont_show_on" value="' . greg_get_option('dont_show_on') . '" /></label></li>
			</ul>';
}*/


function page_postbadge(){
	include GREGARIOUS_ABSPATH.'modules/post-badge/inc_admin.php';
}
?>