<?php
//================================================
// REDDIT-BUTTON MODULE for GREGARIOUS
//================================================
// Provision of a dynamic Reddit button to show
// on blog posts via PostBadge or template tags.
// Three styles of buttons available
//================================================
// Gregarious is copyright 2007 Ankur Kothari
// All rights reserved.
// -------------------------
// http://dev.lipidity.com/wp-plugin-gregarious
//================================================

class module_redditbutton {
	function init(){
		global $gregarious;
		$gregarious->add_settings ( array('reddit_btn_style' => 1) );
		$gregarious->add_page ( 'Reddit', 'modules/reddit-button/icn_Reddit.png', 'page_reddit();', 'redditBadge' );
	}

	function postbadge_tags(){
		return array (
			array (	'tag' => '%REDDIT_1%', 'replacewith' => "reddit_button('style=1',false)", 'deprecate' => 1 ),
			array ( 'tag' => '%REDDIT_2%', 'replacewith' => "reddit_button('style=2',false)", 'deprecate' => 1 ),
			array ( 'tag' => '%REDDIT_3%', 'replacewith' => "reddit_button('style=3',false)", 'deprecate' => 1 ),
			array ( 'tag' => '%REDDIT%', 'replacewith' => "reddit_button('',false)" )
		);
	}

	function update_info(){
		return 100;
	}

}

//------------------------------------------
// TEMPLATE TAGS
//------------------------------------------

function reddit_button($settings='',$echo=true){
	global $wp_query;
	$post = $wp_query->post;
	$sets = array('style' => greg_get_option('reddit_btn_style'), 'postID' => $post->ID);

//	$sets = extract_settings($settings, $sets);
	grab_sets($settings, $sets);
	if ( !$sets['force'] && hideOnID($sets['postID']) ){
		return '';
	} else {
		$result = "<script type='text/javascript'>reddit_url = '".get_permalink($sets['postID'])."';</script><script src='http://reddit.com/button.js?t={$sets['style']}' type='text/javascript'></script>";
		if($echo)echo $result; else return $result;
	}
}

function page_reddit(){
?>
<ul>
	<li class="check">
		<div class="wrapping"><?php _e('Reddit button is on and available in PostBadge.', 'gregarious') ?>
		</div>
	</li>
	<li class="check">
		<label class="wrapping" for="reddit_btn_style"><?php _e('Button Style', 'gregarious') ?> : 
		<select name="reddit_btn_style">
		<option value="1"<?php echo (greg_get_option('reddit_btn_style')==1)?' selected="selected"':''; ?> />Style 1</option>
		<option value="2"<?php echo (greg_get_option('reddit_btn_style')==2)?' selected="selected"':''; ?> />Style 2</option>
		<option value="3"<?php echo (greg_get_option('reddit_btn_style')==3)?' selected="selected"':''; ?> />Style 3</option>
		</select>
		</label>
	</li>

</ul>
<?php
}
?>