<?php
//================================================
// SHARE-THIS MODULE for GREGARIOUS
//================================================
// Provision of "Share This" submit to social sites
// link on blog posts. Social sites listed in
// dialog are configurable
//================================================
// Gregarious is copyright 2007 Ankur Kothari
// All rights reserved.
// -------------------------
// http://dev.lipidity.com/wp-plugin-gregarious
//================================================

class module_sharethis {

	function init(){
		global $gregarious;

		$gregarious->add_page( __('Share This', 'gregarious'), 'modules/share-this/icn_Share.png', 'page_sharethis();', 'shareThis' );
		$gregarious->add_page( __('Social Sites', 'gregarious'), 'modules/share-this/icn_Share.png', 'page_socialsites();', 'socialSites' );
	
	$gregarious->add_settings (array(
		'share_show_link' => 1,
		'share_use_icon' => 1,
		'share_link_text' => 'Share This',
		'share_append_feed' => 1,
		'share_popup' => 1,
		'social_sites' => array(
			'delicious' => array(
				'name' => 'del.icio.us'
				, 'url' => 'http://del.icio.us/post?url={url}&title={title}'
				, 'order' => 1
			)
			, 'digg' => array(
				'name' => 'Digg'
				, 'url' => 'http://digg.com/submit?phase=2&url={url}&title={title}'
				, 'order' => 1
			)
			, 'furl' => array(
				'name' => 'Furl'
				, 'url' => 'http://furl.net/storeIt.jsp?u={url}&t={title}'
				, 'order' => 1
			)
			, 'netscape' => array(
				'name' => 'Netscape'
				, 'url' => 'http://www.netscape.com/submit/?U={url}&T={title}'
				, 'order' => 1
			)
			, 'yahoo_myweb' => array(
				'name' => 'Yahoo! My Web'
				, 'url' => 'http://myweb2.search.yahoo.com/myresults/bookmarklet?u={url}&t={title}'
				, 'order' => 1
			)
			, 'stumbleupon' => array(
				'name' => 'StumbleUpon'
				, 'url' => 'http://www.stumbleupon.com/submit?url={url}&title={title}'
				, 'order' => 1
			)
			, 'google_bmarks' => array(
				'name' => 'Google Bookmarks'
				, 'url' => 'http://www.google.com/bookmarks/mark?op=edit&bkmk={url}&title={title}'
				, 'order' => 1
			)
			, 'technorati' => array(
				'name' => 'Technorati'
				, 'url' => 'http://www.technorati.com/faves?add={url}'
				, 'order' => 1
			)
			, 'blinklist' => array(
				'name' => 'BlinkList'
				, 'url' => 'http://blinklist.com/index.php?Action=Blink/addblink.php&Url={url}&Title={title}'
				, 'order' => 1
			)
			, 'newsvine' => array(
				'name' => 'Newsvine'
				, 'url' => 'http://www.newsvine.com/_wine/save?u={url}&h={title}'
				, 'order' => 1
			)
			, 'magnolia' => array(
				'name' => 'ma.gnolia'
				, 'url' => 'http://ma.gnolia.com/bookmarklet/add?url={url}&title={title}'
				, 'order' => 1
			)
			, 'reddit' => array(
				'name' => 'reddit'
				, 'url' => 'http://reddit.com/submit?url={url}&title={title}'
				, 'order' => 1
			)
			, 'windows_live' => array(
				'name' => 'Windows Live'
				, 'url' => 'https://favorites.live.com/quickadd.aspx?marklet=1&mkt=en-us&url={url}&title={title}&top=1'
				, 'order' => 1
			)
			, 'tailrank' => array(
				'name' => 'Tailrank'
				, 'url' => 'http://tailrank.com/share/?link_href={url}&title={title}'
				, 'order' => 1
			)
			, '9rules' => array(
				'name' => '9rules Clips'
				, 'url' => 'http://9rules.com/clips/post/?url={url}'
				, 'order' => 1
			)
		)
	) );
	}

	function admin_js(){
		include GREGARIOUS_ABSPATH.'modules/share-this/inc_admin-js.php';
	}

	function save_settings (){
		greg_update_option( 'social_sites', sortByField($_REQUEST['social_sites'],'order',1) );
		write_stuff_to_file('css', akst_print_css());
		write_stuff_to_file('js', akst_print_js());
	}

	function reset_settings (){
		write_stuff_to_file('css', akst_print_css());
		write_stuff_to_file('js', akst_print_js());
	}

	function postbadge_tags(){
		return array (
		array ( 'tag' => '%SHARE_THIS%', 'replacewith' => 'share_this("",false)', 'deprecate' => 1 ),
		array ( 'tag' => '%SHARE%', 'replacewith' => 'share_this("",false)' )
		);
	}

	function update_info(){
		return 100;
	}

}

$akst_action = '';

function is_akst_page(){
	if (!empty($_REQUEST['akst_action'])) {
		if ('share-this' == $_REQUEST['akst_action'])
			return true;
	}
	return false;
}
function hybrid_akst_request_handler() {
	if (!empty($_REQUEST['akst_action'])) {
		switch ($_REQUEST['akst_action']) {
			case 'share-this':
				akst_page();
				break;
			case 'send_mail':
				akst_send_mail();
				break;
		}
	}
}
add_action('init', 'hybrid_akst_request_handler', 9999);		

if( greg_get_option('share_append_feed') ){
	add_action('the_content', 'share_feed');
	add_action('the_content_rss', 'share_feed');
}
if( greg_get_option('share_popup') ){
	add_action('wp_footer', 'hybrid_akst_share_form');
	add_action('wp_head', 'gregarious_akst_head');
}

function gregarious_akst_head() {
	echo '
<link rel="stylesheet" type="text/css" href="'.greg_uri().'modules/share-this/akst.css" />
';
}

function hybrid_akst_share_form() {
	global $post, $current_user;

	if (isset($current_user)) {
		$user = get_currentuserinfo();
		$name = $current_user->user_nicename;
		$email = $current_user->user_email;
	}
	else {
		$user = wp_get_current_commenter();
		$name = $user['comment_author'];
		$email = $user['comment_author_email'];
	}
?>
	<!-- Share This BEGIN -->
	<div id="akst_form">
		<a href="javascript:void($el('akst_form').style.display='none');" class="akst_close"><?php _e('Close', 'gregarious'); ?></a>
		<ul class="tabs">
			<li id="akst_tab1" class="selected" onclick="akst_share_tab('1');"><?php _e('Social Web', 'gregarious'); ?></li>
			<li id="akst_tab2" onclick="akst_share_tab('2');"><?php _e('E-mail', 'gregarious'); ?></li>
		</ul>
		<div class="clear"></div>
		<div id="akst_social">
			<ul>
<?php
$socials = greg_get_option('social_sites');
if( is_array($socials) ){
	foreach ($socials as $key => $data) {
		print('				<li><a href="#" id="akst_'.$key.'">'.$data['name'].'</a></li>'."\n");
	}
}
?>
			</ul>
			<div class="clear"></div>
		</div>
		<div id="akst_email">
			<form action="<?php bloginfo('wpurl'); ?>/index.php" method="post">
				<fieldset>
					<legend><?php _e('E-mail It', 'gregarious'); ?></legend>
					<ul>
						<li>
							<label for="akst_to"><?php _e('To Address:', 'gregarious'); ?></label>
							<input type="text" name="akst_to" id="akst_to" value="" class="akst_text" alt="Send to" />
						</li>
						<li>
							<label for="akst_name"><?php _e('Your Name:', 'gregarious'); ?></label>
							<input type="text" name="akst_name" id="akst_name" value="<?php print(htmlspecialchars($name)); ?>" class="akst_text" alt="Your name" />
						</li>
						<li>
							<label for="akst_email_input"><?php _e('Your Address:', 'gregarious'); ?></label>
							<input type="text" name="akst_email" id="akst_email_input" value="<?php print(htmlspecialchars($email)); ?>" class="akst_text" alt="Your email" />
						</li>
						<li>
							<input type="submit" name="akst_submit" value="<?php _e('Send It', 'gregarious'); ?>" />
						</li>
					</ul>
					<input type="hidden" name="akst_action" value="send_mail" />
					<input type="hidden" name="akst_post_id" id="akst_post_id" value="" />
				</fieldset>
			</form>
		</div>
	</div>
	<!-- Share This END -->
<?php
	if( greg_get_option('share_popup') ){
	echo '<script type="text/javascript" src="'.greg_uri().'modules/share-this/akst.js"></script>
';
	}
}

//------------------------------------------
// TEMPLATE TAGS
//------------------------------------------

function share_this($settings='',$echo=true){
	global $akst_action, $post;
	$result = "";
	$sets = array('use_icon' => greg_get_option('share_use_icon'),
	'link_text' => greg_get_option('share_link_text'),
	'postID' => $post->ID,
	'force' => 0);

	grab_sets($settings, $sets);
	if ( !$sets['force'] && hideOnID($sets['postID']) ){
		return '';
	}
	$result .= '<span class="akst_link">';

	if (is_feed() || (function_exists('akm_check_mobile') && akm_check_mobile())) {
		$onclick = '';
	} else {
		$onclick = 'onclick="akst_share(\''.$sets['postID'].'\', \''.urlencode(get_permalink($sets['postID'])).'\', \''.urlencode(get_the_title($sets['postID'])).'\'); return false;"';
	}
	ob_start();
?>
<a href="<?php bloginfo('siteurl'); ?>/?p=<?php print($sets['postID']); ?>&amp;akst_action=share-this" <?php print($onclick); ?> title="<?php _e('E-mail this, post to del.icio.us, etc.', 'gregarious'); ?>" id="akst_link_<?php print($sets['postID']); ?>"<?php echo ($sets['use_icon']) ?'  class="akst_share_link"' : ''; ?>><?php echo attribute_escape($sets['link_text']); ?></a>
<?php
	$link = ob_get_contents();
	ob_end_clean();
	
	$result .= $link;
	$result .= '</span>';
	if( !in_array($akst_action, array('page')) ){
		if($echo)echo $result; else return $result;
	} else {
		return '';
	}
}

function share_feed($content='', $echo=false){
	if(is_feed())
		if($echo) echo $content.share_this('',false); else return $content.share_this('',false);
	else return $content;
}

//===========================================================================
// SHARE THIS FUNCTIONS (IDENTICAL OR ANALOGOUS TO ALEX KING'S)
//===========================================================================
if( !function_exists('akst_share_link') ){
	function akst_share_link() {
			share_this();
	}
}

if( !function_exists('akst_send_mail') ){
function akst_send_mail() {
	$post_id = '';
	$to = '';
	$name = '';
	$email = '';
	if (!empty($_REQUEST['akst_to'])) {
		$to = stripslashes($_REQUEST['akst_to']);
		$to = strip_tags($to);
		$to = str_replace(
			array(
				','
				,"\n"
				,"\t"
				,"\r"
			)
			, array()
			, $to
		);
	}
	if (!empty($_REQUEST['akst_name'])) {
		$name = stripslashes($_REQUEST['akst_name']);
		$name = strip_tags($name);
		$name = str_replace(
			array(
				'"'
				,"\n"
				,"\t"
				,"\r"
			)
			, array()
			, $name
		);
	}
	if (!empty($_REQUEST['akst_email'])) {
		$email = stripslashes($_REQUEST['akst_email']);
		$email = strip_tags($email);
		$email = str_replace(
			array(
				','
				,"\n"
				,"\t"
				,"\r"
			)
			, array()
			, $email
		);
	}
	if (!empty($_REQUEST['akst_post_id'])) {
		$post_id = intval($_REQUEST['akst_post_id']);
	}
	if (empty($post_id) || empty($to) || !ak_check_email_address($to) || empty($email) || !ak_check_email_address($email)) {
		wp_die(__('Click your <strong>back button</strong> and make sure those e-mail addresses are valid then try again.', 'gregarious'));
	}
//	$post = &get_post($post_id);
	$headers = "MIME-Version: 1.0\n" .
		'From: "'.$name.'" <'.$email.'>'."\n"
		.'Reply-To: "'.$name.'" <'.$email.'>'."\n"
		.'Return-Path: "'.$name.'" <'.$email.'>'."\n"
		."Content-Type: text/plain; charset=\"" . get_option('blog_charset') ."\"\n";
	$subject = __('Check out this post on ', 'gregarious').get_bloginfo('name');
	$message = __('Greetings--', 'gregarious')."\n\n"
		.$name.__(' thinks this will be of interest to you:', 'gregarious')."\n\n"
		.ak_decode_entities(get_the_title($post_id))."\n\n"
		.get_permalink($post_id)."\n\n"
		.__('Enjoy.', 'gregarious')."\n\n"
		.'--'."\n"
		.get_bloginfo('home')."\n";
	@wp_mail($to, $subject, $message, $headers);
	if (!empty($_SERVER['HTTP_REFERER'])) {
		$url = $_SERVER['HTTP_REFERER'];
	}
	header("Location: $url");
	status_header('302');
	die();
}
}

if( !function_exists('akst_hide_pop') ){
function akst_hide_pop() {
	return false;
}
}

if( !function_exists('akst_page') ){
function akst_page() {
	include GREGARIOUS_ABSPATH.'modules/share-this/inc_page.php';
}
}

if (!function_exists('ak_check_email_address')) {
	function ak_check_email_address($email) {
// From: http://www.ilovejackdaniels.com/php/email-address-validation/
// First, we check that there's one @ symbol, and that the lengths are right
		if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {
			// Email invalid because wrong number of characters in one section, or wrong number of @ symbols.
			return false;
		}
// Split it into sections to make life easier
		$email_array = explode("@", $email);
		$local_array = explode(".", $email_array[0]);
		for ($i = 0; $i < sizeof($local_array); $i++) {
			 if (!ereg("^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[$i])) {
				return false;
			}
		}	
		if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) {
			// Check if domain is IP. If not, it should be valid domain name
			$domain_array = explode(".", $email_array[1]);
			if (sizeof($domain_array) < 2) {
					return false;
					// Not enough parts to domain
			}
			for ($i = 0; $i < sizeof($domain_array); $i++) {
				if (!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) {
					return false;
				}
			}
		}
		return true;
	}
}

if (!function_exists('ak_decode_entities')) {
	function ak_decode_entities($text, $quote_style = ENT_COMPAT) {
		if (function_exists('html_entity_decode')) {
			$text = html_entity_decode($text, $quote_style, 'ISO-8859-1');
		}
		else { 
			$trans_tbl = get_html_translation_table(HTML_ENTITIES, $quote_style);
			$trans_tbl = array_flip($trans_tbl);
			$text = strtr($text, $trans_tbl);
		}
		$text = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $text); 
		$text = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $text);
		return $text;
	}
}

if(greg_is_admin()) include GREGARIOUS_ABSPATH.'modules/share-this/inc_admin.php';

?>